package com.objis.demothreadexecutor;

import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.FutureTask;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.TimeoutException;

import com.objis.demothreadexecutor.callable.MaTacheQuiRetourneQuelqueChose;

public class DemoFutureTask {

	public static void main(String[] args) {
		MaTacheQuiRetourneQuelqueChose callable1 = new MaTacheQuiRetourneQuelqueChose(1000);
		MaTacheQuiRetourneQuelqueChose callable2 = new MaTacheQuiRetourneQuelqueChose(2000);

		FutureTask<String> futureTask1 = new FutureTask<String>(callable1);
		FutureTask<String> futureTask2 = new FutureTask<String>(callable2);

		ExecutorService executor = Executors.newFixedThreadPool(2);
		executor.execute(futureTask1);
		executor.execute(futureTask2);

		while (true) {
			try {
				if (futureTask1.isDone() && futureTask2.isDone()) {
					System.out.println("Done");
					// fermer l'executor
					executor.shutdown();
					return;
				}

				if (!futureTask1.isDone()) {
					// wait indefinitely for future task to complete
					System.out.println("FutureTask1 : le retour est ="
							+ futureTask1.get());
				}

				System.out.println("Attente de la fin de FutureTask2 ");
				String s = futureTask2.get(200L, TimeUnit.MILLISECONDS);
				if (s != null) {
					System.out.println("FutureTask2 : le retour est =" + s);
				}
			} catch (InterruptedException | ExecutionException e) {
				e.printStackTrace();
			} catch (TimeoutException e) {
				// ne fait rien
			}
		}
	}
}
